
/* All conditionals taken outside of loop and loop replicated, if Cyc == 2. */
/* This file contains all the proceedures for each instance of hh.mat loop.*/
/* Cyc (i,j) loops unwrapped for speed, if Cyc == 1 | 2. */
/*jcr24jul90*/

#include "local.h"
#include <math.h>
#include <stdio.h>  /*For NULL definition*/
#include "em.typ"
#include "hharray.h"
#include "son.h"

/*Global variables for hh array load*/
extern Rtyp ff_re,ff_im;
extern int Capm,Capn,Capm2,Capn2;
extern int loss,xsym;
extern int mo_odd,no_odd;
extern struct hharray hh;
extern int gx,gy;  /* = 1 for cos, = 0 for sin */
extern void (*ffp)();  /*pointer to function to do ff term, e.g., ff*/
extern int *ni0,*mi0;
extern Rtyp *hre,*him,*hrez,*himz;

hlp20c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp20c2*/

hlp24c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* mo_odd && !no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp24c2*/

hlp16c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && !no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp16c2*/

hlp15c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && no_odd && gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp15c1*/

hlp7c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && no_odd && gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp7c1*/

hlp11c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /*mo_odd && !no_odd && gx && gy*/

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp11c1*/

hlp3c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && !no_odd && gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp3c1*/

hlp13c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp13c1*/

hlp5c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp5c1*/

hlp9c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && !no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp9c1*/

hlp1c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && !no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp1c1*/

hlp14c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp14c1*/

hlp6c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp6c1*/

hlp10c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && !no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp10c1*/

hlp2c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && !no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp2c1*/

hlp12c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp12c1*/

hlp4c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp4c1*/

hlp8c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && !no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp8c1*/

hlp0c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && !no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp0c1*/

hlp31c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /*loss &&  mo_odd && no_odd && gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp31c1*/

hlp23c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && no_odd && gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp23c1*/

hlp27c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /*mo_odd && !no_odd && gx && gy*/

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp27c1*/

hlp19c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && !no_odd && gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp19c1*/

hlp29c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* mo_odd && no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp29c1*/

hlp21c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp21c1*/

hlp25c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* mo_odd && !no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp25c1*/

hlp17c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && !no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp17c1*/

hlp30c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* mo_odd && no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp30c1*/

hlp22c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp22c1*/

hlp26c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* mo_odd && !no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp26c1*/

hlp18c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && !no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp18c1*/

hlp28c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* mo_odd && no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp28c1*/

hlp20c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp20c1*/

hlp24c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* mo_odd && !no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp24c1*/

hlp16c1()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && !no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp16c1*/

int *h_indices(start,len)  int start,len;
/*************************************************************/
/* Allocate and init array of indices for hh.mat interpolate.*/
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr25jul90 */ 
{ int skip,start_skip,skip1,start_skip1;
  int *mi,*mi1;
  int mval;

  mi = mi1 = (int *)new((len+2)*sizeof(int));

  /*Set skip and start based on length*/
  skip = 1 + (int)sqrt( len/63.0 ); 
  start_skip = len>>3;
  if (start_skip<3) start_skip=3;
  skip1 = skip + 1;  start_skip1 = start_skip - 1;
  mval = *mi = start;

  while(1)
  { mi++;
    if (mval<start_skip || mval>len-3) mval++;
    else
    { mval += (1==(mval-start_skip1)%skip1) ? skip : 1;
      if (mval>len-3) mval = len-2;
    }
    if (mval >= len) { *mi = -1;  return(mi1); }
    *mi = mval;
  }

} /*h_indices*/

hk_interp(A,ind) Rtyp *A;  int *ind;
/*************************************************************/
/* Fill in the missing points of A.                          */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr21feb89 */ 
{ Rtyp a0,a1,a2,a3;
  Rtyp xx,y0,y1,y2,y3;
  int x,x0,x1,x2,x3;

  /*Initialize the first set of four points*/
  x0 = *(ind++), x1 = *(ind++), x2 = *(ind++), x3 = *(ind++);
  if (x0<0 || x1<0 || x2<0 ) return;
  for ( ; x3 > 0;
        x0 = x1,  x1 = x2,  x2 = x3, x3 = *(ind++) ) if (x2>x1+1)
  { y0 = *(A+x0);  y1 = *(A+x1);  y2 = *(A+x2);  y3 = *(A+x3);
    /*Calculate the interpolation coefficients*/
    a0 = y0;
    a1 = (y1-a0) / (x1-x0);
    a2 = (y2-y1 ) / (x2-x1) - a1;
    a2 /= (x2-x0);
    a3 = (y3-y2) / (x3-x2) - (y2-y1) / (x2-x1);
    a3 /= (x3-x1);
    a3 = (a3-a2) / (x3-x0);
    a2 -= (x2+x1+x0)*a3;
    a1 -= (x1+x0)*a2;
    a1 -= (x1*x1+x1*x0+x0*x0)*a3;
    a0 -= x0*(a1+x0*(a2+x0*a3));
    /*Do the interpolation*/
    for (x=x1+1; x<x2; x++)
    { xx = (Rtyp)x;
      *(A+x) = a0 + xx * ( a1 + xx * ( a2 + xx * a3 ) );
    }
  }
} /*hk_interp*/

cs_fft(A,gcos,odd,sym,N)  Rtyp *A;  int gcos,odd,sym,N;
/*************************************************************/
/* Oversee evaluation of the appropriate cos/sin series.     */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr17feb89 */ 
{ int M,Ntry;

  /*If N=0, we just want to free temp dynamic arrays*/
  if (N==0)
  { cs_fft_sym(NULL,NULL,0,0);  /*This one also cleans out cs_fft_full*/
    cs_dft_full(NULL,0,0,0);
    cs_dft_sym(NULL,0,0,0);
    return;
  }

  /*Calculate M=log2(N)*/
  for (M=0,Ntry=1; Ntry<N; Ntry=Ntry<<1)
    if ( (++M)>=16 )
    { fprintf(stderr,"\nem: bad cs_fft size.\n");
      announce_bug("cs_fft");
    }

  /*If N is not a power of two, just do a dft*/
  if (N != 1<<M || N<16)
  { if (sym) cs_dft_sym(A,gcos,odd,N);
    else     cs_dft_full(A,gcos,odd,N);
    return;
  }

  if (sym) { if (gcos) cs_fft_sym(A,NULL,odd,M);
             else      cs_fft_sym(NULL,A,odd,M);
	   }
  else     { if (gcos) cs_fft_full(A,NULL,odd,M);
             else      cs_fft_full(NULL,A,odd,M);
           }

} /*cs_fft*/

cs_dft_full(A,gcos,odd,N0)  Rtyp *A;  int gcos,odd,N0;
/*************************************************************/
/* Do a full cos/sin series (0..N/2).                        */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr23feb89 */ 
/*Ac or As pts to N/2 items and returns N/2+1 (!odd) or N/2 (odd) items.*/
/*To clean up dynamic allocations, call with N0=0*/
{ static Rtyp *B=NULL;
  static Rtyp *cos_arr=NULL;
  static int Nc=0;
  static int Nb=0;
  static int gcos_sto=0;
  int i,n,k,N2,N3,N4;
  Rtyp rtmp;
  register Rtyp rrtmp;

  if (N0==0)  /*Clean up and return*/
  { if (B!=NULL) sFree( (char *)B);  B = NULL;  Nb = 0;
    if (cos_arr!=NULL) sFree( (char *)cos_arr);  cos_arr = NULL;  Nc = 0;
    return;
  }

  odd = !!odd;
  N2 = N0>>1;  N3 = N2 + !(odd);  N4 = 2*N0;

  /*Check that enough memory is allocated for B*/
  if (Nb<N0)
  { if (B!=NULL) sFree( (char *)B);
    B = (Rtyp *)new( N2*sizeof(Rtyp) );  Nb = N0;
  }
  /*Copy A into B*/
  for (i=0; i<N2; i++) *(B+i) = *(A+i);

  /*Set up the cos (or sin) arrays*/
  if (Nc!=N0 || gcos!=gcos_sto)
  { if (cos_arr!=NULL) sFree( (char *)cos_arr);
    cos_arr = (Rtyp *)new(N4*sizeof(Rtyp));  Nc = N0;  gcos_sto = gcos;
    rtmp = PI/N0;
    if (gcos) for (i=0; i<N4; i++) *(cos_arr+i) = cos(i*rtmp);
    else      for (i=0; i<N4; i++) *(cos_arr+i) = sin(i*rtmp);
  }

  /*Do the dft*/
  for (i=0; i<N3; i++)
  { rrtmp = 0.0;  k =  2*i + odd;
    for (n=0; n<N2; n++) rrtmp += *(B+n) * *(cos_arr + (n*k)%N4); 
    *(A+i) = rrtmp;
  }

} /*cs_dft_full*/

cs_dft_sym(A,gcos,odd,N0)  Rtyp *A;  int gcos,odd,N0;
/*************************************************************/
/* Do a full cos/sin series (0..N/2).                        */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr23feb89 */ 
/*Ac or As pts to N/2 items and returns N/2+1 (!odd) or N/2 (odd) items.*/
/*To clean up dynamic allocations, call with N0=0*/
{ static Rtyp *B=NULL;
  static Rtyp *cos_arr=NULL;
  static int Nc=0;
  static int Nb=0;
  static int gcos_sto=0;
  int i,n,k,N2,N3,N4,NN4;
  Rtyp rtmp;
  register Rtyp rrtmp;

  if (N0==0)  /*Clean up and return*/
  { if (B!=NULL) sFree( (char *)B);  B = NULL;  Nb = 0;
    if (cos_arr!=NULL) sFree( (char *)cos_arr);  cos_arr = NULL;  Nc = 0;
    return;
  }

  odd = !!odd;
  N2 = N0>>1;  N3 = ((!odd) && (!(N2&1))) + ((N2+1)>>1);
  N4 = 2*N0;  NN4 = N2>>1;

  /*Check that enough memory is allocated for B*/
  if (Nb<N0)
  { if (B!=NULL) sFree( (char *)B);
    B = (Rtyp *)new( NN4*sizeof(Rtyp) );  Nb = N0;
  }
  /*Copy A into B*/
  for (i=0; i<NN4; i++) *(B+i) = *(A+i);

  /*Set up the cos (or sin) arrays*/
  if (Nc!=N0 || gcos!=gcos_sto)
  { if (cos_arr!=NULL) sFree( (char *)cos_arr);
    cos_arr = (Rtyp *)new(N4*sizeof(Rtyp));  Nc = N0;  gcos_sto = gcos;
    rtmp = PI/N0;
    if (gcos) for (i=0; i<N4; i++) *(cos_arr+i) = cos(i*rtmp);
    else      for (i=0; i<N4; i++) *(cos_arr+i) = sin(i*rtmp);
  }

  /*Do the dft*/
  for (i=0; i<N3; i++)
  { rrtmp = 0.0;  k =  2*i + odd;
    for (n=0; n<N2; n++) if (n&1) rrtmp += *(B+(n>>1)) * *(cos_arr + (n*k)%N4); 
    *(A+i) = rrtmp;
  }

} /*cs_dft_sym*/

cs_fft_full(Ac,As,odd,M) Rtyp *Ac,*As;  int odd,M;
/*************************************************************/
/* Do a full cos/sin series (0..N/2).                        */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr17feb89 */ 
/*Ac or As pts to N/2 items and returns N/2+1 (!odd) or N/2 (odd) items.*/
/*For just a cosine series, As==NULL; Sine series, Ac==NULL.  For both*/
/*Pass nums in Ac and have As point to N/2 or N/2+1 items*/
/*To clean up dynamic allocations, call with M=0*/
{ static Rtyp *B=NULL;
  static Rtyp *C=NULL;
  static Rtyp *sin_arr=NULL;
  static Rtyp *cos_arr=NULL;
  static int Ncs=0;
  static int Nb=0;
  static int Nc=0;
  int i,N,N2;
  Rtyp rtmp;

  if (M==0)  /*Clean up and return*/
  { if (B!=NULL) sFree( (char *)B);  B = NULL;  Nb = 0;
    if (C!=NULL) sFree( (char *)C);  C = NULL;  Nc = 0;
    if (sin_arr!=NULL) sFree( (char *)sin_arr);  sin_arr = NULL;  Ncs = 0;
    if (cos_arr!=NULL) sFree( (char *)cos_arr);  cos_arr = NULL;
    return;
  }

  N = 1<<M;  N2 = N>>1;

  /*Check that enough memory is allocated for B*/
  if (Nb<N)
  { if (B!=NULL) sFree( (char *)B);
    B = (Rtyp *)new( (N+2)*sizeof(Rtyp) );  Nb = N;
  }
  /*Clear the tail end of B*/
  for (i=N2; i<(N+2); i++) *(B+i) = 0.0;

  /*Do the FFT for the even case*/
  if (!odd)
  { if (Ac) for (i=0; i<N2; i++) *(B+i) = *(Ac+i);
    else for (i=0; i<N2; i++) *(B+i) = *(As+i);
    ffb(B,M);
    if (Ac) for (i=0; i<=N2; i++) *(Ac+i) = *(B+2*i);
    if (As) for (i=0; i<=N2; i++) *(As+i) = - *(B+2*i+1);
    return;
  }

  /*Only odd case now*/
  /*Set up the sin and cos arrays*/
  if (Ncs!=N)
  { if (sin_arr!=NULL) { sFree( (char *)cos_arr);  sFree( (char *)sin_arr); }
    sin_arr = (Rtyp *)new(N2*sizeof(Rtyp));  Ncs = N;
    cos_arr = (Rtyp *)new(N2*sizeof(Rtyp));
    rtmp = PI/N;
    for (i=0; i<N2; i++)
    { *(cos_arr+i) = cos(i*rtmp);  *(sin_arr+i) = sin(i*rtmp); }
  }

  if (Nc<N) /*Do set up of C*/
  { if (C!=NULL) sFree( (char *)C);
    C = (Rtyp *)new( (N+2)*sizeof(Rtyp) );  Nc = N;
  }
  /*Clear the tail end of C*/
  for (i=N2; i<(N+2); i++) *(C+i) = 0.0;
  /*Pre-process A and copy into B and C*/
  if (Ac) for (i=0; i<N2; i++)
  { *(C+i) = *(Ac+i) * *(sin_arr+i);  *(B+i) = *(Ac+i) * *(cos_arr+i); }
  else for (i=0; i<N2; i++)
  { *(C+i) = *(As+i) * *(sin_arr+i);  *(B+i) = *(As+i) * *(cos_arr+i); }

  /*Do the FFT for the odd case*/
  ffb(B,M);  ffb(C,M);
  if (Ac) for (i=0; i<N2; i++)  *(Ac+i) = *(B+2*i) + *(C+2*i+1);
  if (As) for (i=0; i<N2; i++)  *(As+i) = *(C+2*i) - *(B+2*i+1);

} /*cs_fft_full*/

cs_fft_sym(Ac,As,odd,M)  Rtyp *Ac,*As;  int odd,M;
/*************************************************************/
/* Do a cos/sin series with only odd mode #'s (0..N/2-1).    */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr17feb89 */ 
/*A points to N/4 numbers and is returned with N/4 numbers
 (odd) or N/4+1 (!odd)*/
/*For just a cosine series, As==NULL; Sine series, Ac==NULL.  For both*/
/*Pass nums in Ac and have As point to N/4 or N/4+1 items*/
{ static Rtyp *Bc=NULL;
  static Rtyp *Bs=NULL;
  static Rtyp *sin_arr=NULL;
  static Rtyp *cos_arr=NULL;
  static int Ncs=0;
  static int Nb=0;
  int i,N,N2,N4;
  Rtyp rtmp;

  if (M==0)  /*Clean up and return*/
  { if (Bc!=NULL) sFree( (char *)Bc);  Bc = NULL;  Nb = 0;
    if (Bs!=NULL) sFree( (char *)Bs);  Bs = NULL;
    if (sin_arr!=NULL) sFree( (char *)sin_arr);  sin_arr = NULL;  Ncs = 0;
    if (cos_arr!=NULL) sFree( (char *)cos_arr);  cos_arr = NULL;
    cs_fft_full(NULL,NULL,0,0);
    return;
  }

  N = 1<<M;  N2 = N>>1;  N4 = N2>>1;

  /*Check that enough memory is allocated for Bc,Bs*/
  if (Nb<N)
  { if (Bc!=NULL) sFree( (char *)Bc);
    Bc = (Rtyp *)new( (N4+1)*sizeof(Rtyp) );  Nb = N;
    if (Bs!=NULL) sFree( (char *)Bs);
    Bs = (Rtyp *)new( (N4+1)*sizeof(Rtyp) );
  }
  /*Copy Ac or As into Bc*/
  if (Ac) for (i=0; i<N4; i++) *(Bc+i) = *(Ac+i);
  else    for (i=0; i<N4; i++) *(Bc+i) = *(As+i);

  /*Get both the cos and sin series*/
  cs_fft_full(Bc,Bs,odd,M-1);

  /*Set up the sin and cos arrays*/
  if (Ncs!=N)
  { if (sin_arr!=NULL) { sFree( (char *)cos_arr);  sFree( (char *)sin_arr); }
    sin_arr = (Rtyp *)new((N4+1)*sizeof(Rtyp));  Ncs = N;
    cos_arr = (Rtyp *)new((N4+1)*sizeof(Rtyp));
    rtmp = PI/N;
    if (odd) for (i=0; i<N4; i++)
	     { *(cos_arr+i) = cos((2*i+1)*rtmp);  *(sin_arr+i) = sin((2*i+1)*rtmp); }
    else     for (i=0; i<=N4; i++)
	     { *(cos_arr+i) = cos(2*i*rtmp);  *(sin_arr+i) = sin(2*i*rtmp); }
  }

  /*Finish it off*/
  if (Ac)
  { for (i=0; i<N4; i++)
      *(Ac+i) = *(Bc+i) * *(cos_arr+i) - *(Bs+i) * *(sin_arr+i);
    if (!odd) *(Ac+N4) = *(Bc+N4) * *(cos_arr+N4) - *(Bs+N4) * *(sin_arr+N4);
  }
  if (As)
  { for (i=0; i<N4; i++)
      *(As+i) = *(Bc+i) * *(sin_arr+i) + *(Bs+i) * *(cos_arr+i);
    if (!odd) *(As+N4) = *(Bc+N4) * *(sin_arr+N4) + *(Bs+N4) * *(cos_arr+N4);
  }
} /*cs_fft_sym*/
